/***************************************************************************
 * U. Minnesota LPD Software * Copyright 1987, 1988, Patrick Powell
 * version 3.3.0 Justin Mason July 1994
 ***************************************************************************
 * MODULE: Print_stty.c
 * handle tty line settings to the printer -- isolated by <jmason@iona.ie>
 ***************************************************************************
 * int Do_stty(): set tty line settings
 ***************************************************************************/

#include "lp.h"
#include "library/errormsg.h"
#include "LPD/term.h"

#ifdef USE_TERMIOS
#include "LPD/stty_termios.c"

#else
#ifdef USE_TERMIO
#include "LPD/stty_termio.c"

#else
#ifdef USE_SGTTY
#include "LPD/stty_sgtty.c"

#else
void Do_stty (int fd) {
    logerr_die (XLOG_NOTICE, "no support for stty!\n");
}

#endif				/* USE_SGTTY */
#endif				/* USE_TERMIO */
#endif				/* USE_TERMIOS */
